(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue'), require('vue-class-component'), require('vuex')) :
	typeof define === 'function' && define.amd ? define(['exports', 'vue', 'vue-class-component', 'vuex'], factory) :
	(factory((global.VueTypescript = {}),global.Vue,global.VueClassComponent,global.Vuex));
}(this, (function (exports,vue,vueClassComponent,vuex) { 'use strict';

vue = vue && vue.hasOwnProperty('default') ? vue['default'] : vue;
var vueClassComponent__default = 'default' in vueClassComponent ? vueClassComponent['default'] : vueClassComponent;

function createExDecorator(factory) {
    return function (target, key, descriptor) {
        var c = vueClassComponent.createDecorator(function (o, k) {
            return factory(o, k, descriptor);
        });
        return c(target, key);
    };
}

function Filter() {
    return createExDecorator(function (componentOptions, k, descriptor) {
        debugger;
        if (typeof componentOptions.filters !== 'object') {
            componentOptions.filters = Object.create(null);
        }
        componentOptions.filters[k] = descriptor.value;
    });
}

function Prop(options) {
    if (options === void 0) { options = {}; }
    return vueClassComponent.createDecorator(function (componentOptions, k) {
        if (typeof componentOptions.props !== 'object') {
            componentOptions.props = Object.create(null);
        }
        componentOptions.props[k] = options;
    });
}

function Watch(path, options) {
    if (options === void 0) { options = {}; }
    var _a = options.deep, deep = _a === void 0 ? false : _a, _b = options.immediate, immediate = _b === void 0 ? false : _b;
    return vueClassComponent.createDecorator(function (componentOptions, handler) {
        if (typeof componentOptions.watch !== 'object') {
            componentOptions.watch = Object.create(null);
        }
        componentOptions.watch[path] = { handler: handler, deep: deep, immediate: immediate };
    });
}

function isVuexModuleKey(key) {
    return ['namespaced', 'state', 'getters', 'actions', 'mutations', 'modules'].indexOf(key) >= 0;
}
function shouldAddPropertyToState(state, key) {
    return state.hasOwnProperty(key) &&
        typeof state[key] !== 'function' &&
        !isVuexModuleKey(key);
}
function moduleDecoratorFactory(modOrOpt) {
    return function (constructor) {
        var module = constructor;
        var state = new (module.prototype.constructor)({});
        if (typeof module.state !== 'object') {
            module.state = Object.create(null);
        }
        module.namespaced = modOrOpt && modOrOpt.namespaced;
        Object.keys(state).forEach(function (key) {
            if (shouldAddPropertyToState(state, key)) {
                module.state[key] = state[key];
            }
        });
    };
}
var VuexModule = /** @class */ (function () {
    function VuexModule(module) {
        this.actions = module.actions;
        this.mutations = module.mutations;
        this.state = module.state;
        this.getters = module.getters;
        this.namespaced = module.namespaced;
        this.modules = module.modules;
    }
    return VuexModule;
}());
function Module(modOrOpt) {
    if (typeof modOrOpt === 'function') {
        return moduleDecoratorFactory({})(modOrOpt);
    }
    else {
        return moduleDecoratorFactory(modOrOpt);
    }
}

function createVuexDecorator(factory) {
    return function (target, key, descriptor) {
        var options = typeof target === 'function'
            ? target
            : target.constructor;
        factory(options, key, descriptor);
    };
}

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
function createActionFunction(key, value, options) {
    var action = function (context, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var actionPayload, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, value.call(context, payload)];
                    case 1:
                        actionPayload = _a.sent();
                        if (options && options.commit) {
                            context.commit(options.commit, actionPayload);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        console.error('Could not perform action ' + key.toString());
                        console.error(e_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return action;
}
function Action(options) {
    if (options === void 0) { options = {}; }
    return createVuexDecorator(function (componentOptions, k, description) {
        if (typeof componentOptions.actions !== 'object') {
            componentOptions.actions = Object.create(null);
        }
        componentOptions.actions[k] = createActionFunction(k, description.value, options);
    });
}

function createMutationFunction(value) {
    var mutation = function (state, payload) {
        value.call(state, payload);
    };
    return mutation;
}
function Mutation() {
    return createVuexDecorator(function (componentOptions, k, description) {
        if (typeof componentOptions.mutations !== 'object') {
            componentOptions.mutations = Object.create(null);
        }
        componentOptions.mutations[k] = createMutationFunction(description.value);
    });
}

function createGetterFunction(value) {
    var getter = function (state) {
        return value.call(state);
    };
    return getter;
}
function Getter() {
    return createVuexDecorator(function (componentOptions, k, description) {
        if (typeof componentOptions.getters !== 'object') {
            componentOptions.getters = Object.create(null);
        }
        componentOptions.getters[k] = createGetterFunction(description.value);
    });
}

function MapAction(options) {
    if (options === void 0) { options = {}; }
    var _a = options.namespace, namespace = _a === void 0 ? undefined : _a;
    return vueClassComponent.createDecorator(function (componentOptions, k) {
        if (typeof componentOptions.methods !== 'object') {
            componentOptions.methods = Object.create(null);
        }
        var mapArray = [k];
        componentOptions.methods[k] = namespace !== undefined
            ? vuex.mapActions(namespace, mapArray)[k]
            : vuex.mapActions(mapArray)[k];
    });
}

function MapGetter(options) {
    if (options === void 0) { options = {}; }
    var _a = options.namespace, namespace = _a === void 0 ? undefined : _a;
    return vueClassComponent.createDecorator(function (componentOptions, k) {
        if (typeof componentOptions.computed !== 'object') {
            componentOptions.computed = Object.create(null);
        }
        var mapArray = [k];
        componentOptions.computed[k] = namespace !== undefined
            ? vuex.mapGetters(namespace, mapArray)[k]
            : vuex.mapGetters(mapArray)[k];
    });
}

exports.Vue = vue;
exports.Component = vueClassComponent__default;
exports.createDecorator = vueClassComponent.createDecorator;
exports.mixins = vueClassComponent.mixins;
exports.Filter = Filter;
exports.Prop = Prop;
exports.Watch = Watch;
exports.VuexModule = VuexModule;
exports.Module = Module;
exports.Action = Action;
exports.Mutation = Mutation;
exports.Getter = Getter;
exports.MapAction = MapAction;
exports.MapGetter = MapGetter;

Object.defineProperty(exports, '__esModule', { value: true });

})));
